<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class Cdp01000LoteDeProducaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function selectXqry($nrorg, $cdfilial){
        
        $sql = "SELECT
                    IDUTSEGLIBLOTE,
                    IDLIBLOTEEST,
                    NRTPCUSTOOP
                FROM
                    PARAMAN    
                WHERE
                    NRORG     = :NRORG AND
                    CDFILIAL = :CDFILIAL";
                    
        $params = array(
            'NRORG'=>$nrorg,
            'CDFILIAL'=>$cdfilial
        );
        
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetch();
    }
    
    public function selectAdqLocalTerc($nrorg, $cdfilial, $nrloteestq, $nrsublote){
        
        $sql = "SELECT
                    CDFILIAL,
                    NRAUDITORIA,
                    CDFILIALNF,
                    NRLANCTONF,
                    NRSEQITPROD,
                    CDPRODUTO,
                    CDCLIENTE,
                    CDFORNECED,
                    CDTIPOOPER,
                    NRORDPROD,
                    NRSUBORDPROD,
                    IDTPAUDITADO,
                    IDENTRTERCEIRO,
                    IDPEDINDUSTRIA,
                    IDOPTRIANGULAR,
                    CDFORNECEDREME 
                FROM
                    (   SELECT
                            O.CDFILIAL,
                            '' AS NRAUDITORIA,
                            '' AS CDFILIALNF,
                            '' AS NRLANCTONF,
                            '' AS NRSEQITPROD,
                            O.CDPRODUTO,
                            P.CDCLIENTE,
                            '' AS CDFORNECED,
                            P.CDTIPOOPER,
                            O.NRORDPROD,
                            O.NRSUBORDPROD,
                            '' AS IDTPAUDITADO,
                            'N' AS IDENTRTERCEIRO,
                            P.IDPEDINDUSTRIA,
                            'N' AS IDOPTRIANGULAR,
                            '' AS CDFORNECEDREME 
                        FROM
                            ORDPRODUCAO O,
                            PEDIDO P         
                        WHERE
                            (
                                O.NRORG         = :NRORG
                            )           
                            AND (
                                O.CDFILIAL     = :CDFILIAL
                            )           
                            AND (
                                O.NRLOTEESTQ   = :NRLOTEESTQ
                            )           
                            AND (
                                O.NRSUBLOTE    = NVL(:NRSUBLOTE, ' ')
                            )           
                            AND (
                                P.CDFILIAL     = O.CDFILIAL    
                            )           
                            AND (
                                P.NRPEDIDO     = O.NRPEDIDO    
                            )       
                    )";
                    
        $params = array(
            'NRORG'=>$nrorg,
            'CDFILIAL'=>$cdfilial,
            'NRLOTEESTQ'=>$nrloteestq,
            'NRSUBLOTE'=>$nrsublote
        );
        
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetch();
    }
    
    public function selectXqryOrdemProducao($nrorg, $cdfilial, $nrloteestq, $nrsublote, $cdproduto){
        
        $sql = " SELECT
                    NRORDPROD,
                    NRSUBORDPROD      
                FROM
                    ORDPRODUCAO      
                WHERE
                    (
                        NRORG   = :NRORG
                    )            
                    AND    (
                        CDFILIAL   = :CDFILIAL
                    )            
                    AND    (
                        NRLOTEESTQ = :NRLOTEESTQ
                    )          
                    AND    (
                        NRSUBLOTE  = :NRSUBLOTE
                    )           
                    AND    (
                        CDPRODUTO  = :CDPRODUTO
                    )           
                    AND    (
                        IDSITORDPROD = '3'
                    )";
                    
        $params = array(
            'NRORG'=>$nrorg,
            'CDFILIAL'=>$cdfilial,
            'NRLOTEESTQ'=>$nrloteestq,
            'NRSUBLOTE'=>$nrsublote,
            'CDPRODUTO'=>$cdproduto
        );
        
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetch();
    }
    
    public function selectAdqAtividade($nrorg, $cdfilial, $nrordprod, $nrsubordprod){
        
        $sql = "SELECT
                    TODOS.CDPRODUTO,
                    TODOS.NRLOTEESTQ,
                    TODOS.NRSUBLOTE,
                    TODOS.CDARVINSPEC,
                    TODOS.NMINSPECAO,
                    TODOS.IDORIGINSPEC,
                    TODOS.IDTPAUDITADO,
                    A.IDNOK,
                    B.IDPENAND,
                    NVL( 
                		(SELECT
                	            IDTPCONCLETAPA 
                	        FROM
                	            ORDPRODUCAO O,
                	            ETAFABRIC E 
                	        WHERE
                	            O.CDFILIAL = :CDFILIAL 
                	            AND O.NRORDPROD = :NRORDPROD  
                	            AND O.NRSUBORDPROD = :NRSUBORDPROD          
                	            AND E.CDFILIAL = O.CDFILIAL 
                	            AND E.CDPRODUTO = O.CDPRODUTO 
                	            AND E.CDPROCFABRIC = O.CDPROCFABRIC 
                	            AND E.CDETAPAPROD = TODOS.CDETAPAPROD),
                	    'S') AS IDTPCONCLETAPA 
                FROM
                    (SELECT
                        AUDITORIA.CDPRODUTO,
                        AUDITORIA.NRLOTEESTQ,
                        AUDITORIA.NRSUBLOTE,
                        AUDITORIA.IDSTATUSAUDI AS IDNOK ,
                        AUDITORIA.IDTPAUDITADO,
                        INSPECAO.CDARVINSPEC,
                        INSPECAO.NMINSPECAO,
                        INSPECAO.IDORIGINSPEC,
                        AUDITORIA.CDETAPAPROD   
                    FROM
                        INSPECAO,
                        AUDITORIA,
                        INSPECAUDIT   
                    WHERE
                        AUDITORIA.CDFILIAL     = :CDFILIAL             
                        AND       AUDITORIA.NRORDPROD    = :NRORDPROD            
                        AND       AUDITORIA.NRSUBORDPROD = :NRSUBORDPROD         
                        AND       AUDITORIA.IDSTATUSAUDI = '5'                     
                        AND       AUDITORIA.CDFILIAL     = INSPECAUDIT.CDFILIAL    
                        AND       AUDITORIA.NRAUDITORIA  = INSPECAUDIT.NRAUDITORIA 
                        AND       INSPECAUDIT.CDINSPECAO = INSPECAO.CDINSPECAO) A ,
                    (SELECT
                        AUDITORIA.CDPRODUTO,
                        AUDITORIA.NRLOTEESTQ ,
                        AUDITORIA.NRSUBLOTE,
                        AUDITORIA.IDSTATUSAUDI AS IDPENAND,
                        AUDITORIA.IDTPAUDITADO,
                        INSPECAO.CDARVINSPEC,
                        INSPECAO.NMINSPECAO,
                        INSPECAO.IDORIGINSPEC,
                        AUDITORIA.CDETAPAPROD   
                    FROM
                        INSPECAO,
                        AUDITORIA,
                        INSPECAUDIT   
                    WHERE
                        AUDITORIA.CDFILIAL     = :CDFILIAL             
                        AND       AUDITORIA.NRORDPROD    = :NRORDPROD            
                        AND       AUDITORIA.NRSUBORDPROD = :NRSUBORDPROD         
                        AND       AUDITORIA.IDSTATUSAUDI IN (
                            '1','2'
                        )              
                        AND       AUDITORIA.CDFILIAL     = INSPECAUDIT.CDFILIAL    
                        AND       AUDITORIA.NRAUDITORIA  = INSPECAUDIT.NRAUDITORIA 
                        AND       INSPECAUDIT.CDINSPECAO = INSPECAO.CDINSPECAO) B,
                    (SELECT
                        AUDITORIA.CDPRODUTO,
                        AUDITORIA.NRLOTEESTQ,
                        AUDITORIA.NRSUBLOTE,
                        AUDITORIA.IDTPAUDITADO,
                        INSPECAO.CDARVINSPEC,
                        INSPECAO.NMINSPECAO,
                        INSPECAO.IDORIGINSPEC,
                        AUDITORIA.CDETAPAPROD   
                    FROM
                        INSPECAO,
                        AUDITORIA,
                        INSPECAUDIT   
                    WHERE
                        AUDITORIA.CDFILIAL     = :CDFILIAL             
                        AND       AUDITORIA.NRORDPROD    = :NRORDPROD            
                        AND       AUDITORIA.NRSUBORDPROD = :NRSUBORDPROD         
                        AND       AUDITORIA.CDFILIAL     = INSPECAUDIT.CDFILIAL    
                        AND       AUDITORIA.NRAUDITORIA  = INSPECAUDIT.NRAUDITORIA 
                        AND       INSPECAUDIT.CDINSPECAO = INSPECAO.CDINSPECAO) TODOS 
                WHERE
                    TODOS.NRORG = :NRORG
                    AND TODOS.CDPRODUTO    = B.CDPRODUTO(+) 
                    AND TODOS.NRLOTEESTQ = B.NRLOTEESTQ(+) 
                    AND TODOS.NRSUBLOTE = B.NRSUBLOTE (+)
                    AND TODOS.CDARVINSPEC  = B.CDARVINSPEC(+)
                    AND TODOS.NMINSPECAO = B.NMINSPECAO(+)
                    AND TODOS.IDORIGINSPEC = B.IDORIGINSPEC(+)
                    AND TODOS.CDPRODUTO    = A.CDPRODUTO(+)
                    AND TODOS.NRLOTEESTQ   = A.NRLOTEESTQ(+)
                    AND TODOS.NRSUBLOTE    = A.NRSUBLOTE(+)
                    AND TODOS.CDARVINSPEC  = A.CDARVINSPEC(+)
                    AND TODOS.NMINSPECAO = A.NMINSPECAO(+) 
                    AND TODOS.IDORIGINSPEC = A.IDORIGINSPEC(+)";
                    
        $params = array(
            'NRORG'=>$nrorg,
            'CDFILIAL'=>$cdfilial,
            'NRORDPROD'=>$nrordprod,
            'NRSUBORDPROD'=>$nrsubordprod
        );
        
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetch();
    }
    
    public function selectAdqAgenteTerc($nrorg, $cdfilial, $cdcliente, $cdfornecedor){
        
        $sql = "SELECT
                    A.CDFILIAL,
                    A.CDCLIENTE,
                    A.CDFORNECED,
                    A.CDALMOXARIFE,
                    A.CDLOCALESTOQ,
                    A.CDALMOXTERCCLI,
                    A.CDLOCALTERCCLI,
                    A.CDALMOXTERCFOR,
                    A.CDLOCALTERCFOR,
                    P.IDUTILALMOXTERC 
                FROM
                    (SELECT
                        CDFILIAL,
                        CDCLIENTE,
                        '' AS CDFORNECED,
                        CDALMOXARIFE,
                        CDLOCALESTOQ,
                        CDALMOXTERCCLI,
                        CDLOCALTERCCLI,
                        '' AS CDALMOXTERCFOR,
                        '' AS CDLOCALTERCFOR 
                    FROM
                        AGENTETERCECLI 
                    WHERE
                        (
                            CDFILIAL  = :CDFILIAL 
                        ) 
                    AND 
                        (
                            CDCLIENTE = :CDCLIENTE
                        ) 
                    UNION
                    SELECT
                        CDFILIAL,
                        '' AS CDCLIENTE,
                        CDFORNECED,
                        CDALMOXARIFE,
                        CDLOCALESTOQ,
                        '' AS CDALMOXTERCCLI,
                        '' AS CDLOCALTERCCLI,
                        CDALMOXTERCFOR,
                        CDLOCALTERCFOR 
                    FROM
                        AGENTETERCEFOR 
                    WHERE
                        (
                            CDFILIAL   = :CDFILIAL  
                        ) 
                    AND 
                        (
                            CDFORNECED = :CDFORNECED
                        ) 
                    ) A, 
                    PAREXPEDICAO P 
                WHERE
                (
                A.CDFILIAL = P.CDFILIAL
                )";
                    
        $params = array(
            'NRORG'=>$nrorg,
            'CDFILIAL'=>$cdfilial,
            'CDCLIENTE'=>$cdcliente,
            'CDFORNECED'=>$cdfornecedor
        );
        
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetch();
    }
    
}