<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\GER\Utilities\Environment;


class Cdp01000LoteDeProducaoService{
  
    protected $entityManager;
	  protected $environment;
	  protected $Cdp01000LoteDeProducaoFactory;

  	public function __construct(Environment $environment, EntityManager $entityManager, $Cdp01000LoteDeProducaoFactory){
  		$this->environment				= $environment;
  		$this->entityManager           = $entityManager;
  		$this->Cdp01000LoteDeProducaoFactory = $Cdp01000LoteDeProducaoFactory;
  	}
        
    public function liberaLote($rows){
    	try{
          	$connection = $this->entityManager->getConnection();
      	    $connection->beginTransaction();
              
            $stAlmoxQuarentena = '';
            $stLocalQuarentena = '';
            $stAlmoxLiberado   = '';
            $stLocalLiberado   = '';
            
            $inNrCusto;
            $SelectParaman;
          
            $retornoXqry = $this->Cdp01000LoteDeProducaoFactory->selectXqry($rows['NRORG'], $rows['CDFILIAL']);   
            $retornoAdqLocalTerc =  $this->Cdp01000LoteDeProducaoFactory->selectAdqLocalTerc($rows['NRORG'], $rows['CDFILIAL'], $rows['NRLOTEESTQ'], $rows['NRSUBLOTE']);
            
            if(empty($retornoXqry['NRTPCUSTOOP'])){
              $inNrCusto = 3;
            } else {
              $inNrCusto = $retornoXqry['NRTPCUSTOOP'];
            };
            
            if(($retornoXqry['IDUTSEGLIBLOTE'] == 'S') && ($retornoXqry['IDLIBLOTEEST'] == '2')){
              
                $retornoXqryOrdemProducao = $this->Cdp01000LoteDeProducaoFactory->selectXqryOrdemProducao($rows['NRORG'], $rows['CDFILIAL'], $rows['NRLOTEESTQ'], $rows['NRSUBLOTE'], $rows['CDPRODUTO']);
                $retornoAdqAtividade  = $this->Cdp01000LoteDeProducaoFactory->selectAdqAtividade($rows['NRORG'], $rows['CDFILIAL'], $rows['NRORDPROD'], $rows['NRSUBORDPROD']);
                
                $stPri       = 'S';
                $stAnaPen    = 'N';
                $stOutrasPen = 'N';
                
                foreach ($retornoAdqAtividade as $linha) {
                    if($retornoAdqAtividade['IDORIGINSPEC'] == 'TAR') {
                       if(($retornoAdqAtividade['IDPENAND'] == '1') || ($retornoAdqAtividade['IDPENAND'] == '2')){
                          if(stPri == 'S'){
                             Grava_Erro(MSG_1);
                             stPri = 'N'
                          }
        
                          Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_2);
        
                          stOutrasPen = 'S';
                        }
                    }
                    else if($retornoAdqAtividade['IDORIGINSPEC'] == 'QUA'){
                       if(($retornoAdqAtividade['IDPENAND'] == '1') || ($retornoAdqAtividade['IDPENAND'] == '2')){
                          if(stPri == 'S'){
                             Grava_Erro(MSG_1);
                             stPri = 'N';
                          }
                          Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_3);
                          stOutrasPen = 'S';
                       }
                    }
                    else if($retornoAdqAtividade['IDORIGINSPEC'] == 'ANA'){
                       if(($retornoAdqAtividade['IDNOK'] == '5') && (!P_BOREPROV???)){
                          if(stPri == 'S'){
                             Grava_Erro(MSG_1);
                             stPri = 'N';
                          };
          
                          Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_4);
                          stAnaPen = 'S';
                          if(($retornoAdqAtividade['IDTPAUDITADO'] == 'P') || (empty($retornoAdqAtividade['IDTPAUDITADO']))){
                             stOutrasPen = 'S';
                          };
                       }
                       else if(($retornoAdqAtividade['IDPENAND'] == '1') || ($retornoAdqAtividade['IDPENAND'] == '2')){
                          if(stPri == 'S'){
                             Grava_Erro(MSG_1);
                             stPri = 'N'
                          };
                          Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_4);
                          stAnaPen = 'S';
                          if(($retornoAdqAtividade['IDTPAUDITADO'] == 'P') || (empty($retornoAdqAtividade['IDTPAUDITADO']))){
                             stOutrasPen = 'S';
                          };
                       };
                    };
                  adqAtividade.Next;
                };
                
                if(cdsErroFechamento.RecordCount > 0){
                    oleResult[2] := cdsErroFechamento.Data;
                    Result := oleResult;
                    Exit;
                };
                
                if(($retornoAdqLocalTerc['IDENTRTERCEIRO'] == 'S') || ($retornoAdqLocalTerc['IDPEDINDUSTRIA'] == 'S')){
                  if(!(empty($retornoAdqLocalTerc['CDCLIENTE']))){
                     
                    $retornoAdqAgenteTerc = $this->Cdp01000LoteDeProducaoFactory->selectAdqAgenteTerc($rows['NRORG'], $rows['CDFILIAL'], $rows['CDCLIENTE'], $rows['CDFORNECED']);
                        
                     // Verifica se a análise é proveniente de uma OP e se controla produto acabado no almoxarifado de terceiros;
                    if(!(empty($retornoAdqLocalTerc['NRORDPROD']))){
                        if ((!(empty($retornoAdqAgenteTerc['CDALMOXARIFE']))) && (!(empty($retornoAdqAgenteTerc['CDALMOXTERCCLI'])) && ($retornoAdqAgenteTerc['IDUTILALMOXTERC'] == 'S')){
                           $stAlmoxQuarentena = $retornoAdqAgenteTerc['CDALMOXARIFE.'];
                           $stLocalQuarentena = $retornoAdqAgenteTerc['CDLOCALESTOQ.'];
                           $stAlmoxLiberado   = $retornoAdqAgenteTerc['CDALMOXTERCCLI.'];
                           $stLocalLiberado   = $retornoAdqAgenteTerc['CDLOCALTERCCLI.'];
                        }
                    } else {
                        // A análise é proveniente de uma Entrada de terceiros de Cliente;
                        if((!(empty($retornoAdqAgenteTerc['CDALMOXARIFE']))) && (!(empty($retornoAdqAgenteTerc['CDALMOXTERCCLI'])))){
                           $stAlmoxQuarentena = $retornoAdqAgenteTerc['CDALMOXARIFE'];
                           $stLocalQuarentena = $retornoAdqAgenteTerc['CDLOCALESTOQ'];
                           $stAlmoxLiberado   = $retornoAdqAgenteTerc['CDALMOXTERCCLI'];
                           $stLocalLiberado   = $retornoAdqAgenteTerc['CDLOCALTERCCLI'];
                        }
                    }
                } else if ((!(empty($retornoAdqLocalTerc['CDFORNECED']))) && (empty($retornoAdqLocalTerc['CDCLIENTE']))){
                     
                     $rows['CDCLIENTE'] = null;
                     $retornoAdqAgenteTerc = $this->Cdp01000LoteDeProducaoFactory->selectAdqAgenteTerc($rows['NRORG'], $rows['CDFILIAL'], $rows['CDCLIENTE'], $retornoAdqLocalTerc['CDFORNECED']);

                    // A análise é proveniente de uma Entrada de terceiros de Fornecedor;
                    if((!(empty($retornoAdqAgenteTerc['CDALMOXARIFE'])) && (!(empty($retornoAdqAgenteTerc['CDALMOXTERCFOR'])))){
                        $stAlmoxQuarentena = $retornoAdqAgenteTerc['CDALMOXARIFE'];
                        $stLocalQuarentena = $retornoAdqAgenteTerc['CDLOCALESTOQ'];
                        $stAlmoxLiberado   = $retornoAdqAgenteTerc['CDALMOXTERCFOR'];
                        $stLocalLiberado   = $retornoAdqAgenteTerc['CDLOCALTERCFOR'];
                    }
                }
                  // Verifica se a análise é proveniente de uma Operação Triangular;
                if(($retornoAdqLocalTerc['IDOPTRIANGULAR'] == 'S') && (!(empty($retornoAdqLocalTerc['CDFORNECEDREME'])))){
                     
                    $rows['CDCLIENTE'] = null;
                    $retornoAdqAgenteTerc = $this->Cdp01000LoteDeProducaoFactory->selectAdqAgenteTerc($rows['NRORG'], $rows['CDFILIAL'], $rows['CDCLIENTE'], $retornoAdqLocalTerc['CDFORNECEDREME']);

                    if((!(empty($retornoAdqAgenteTerc['CDALMOXARIFE'])) && (!(empty($retornoAdqAgenteTerc['CDALMOXTERCFOR]')))){
                        $stAlmoxQuarentena = $retornoAdqAgenteTerc['CDALMOXARIFE'];
                        $stLocalQuarentena = $retornoAdqAgenteTerc['CDLOCALESTOQ'];
                        $stAlmoxLiberado   = $retornoAdqAgenteTerc['CDALMOXTERCFOR'];
                        $stLocalLiberado   = $retornoAdqAgenteTerc['CDLOCALTERCFOR'];
                    }
                }
                 
            };
            
            
    	  }catch (\Exception $e) {
            $this->entityManager->rollback();
            throw $e;
        }
    }    
  
}