<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;


class Cdp05000RoteiroProducaoService{

	protected $entityManager;
	protected $environment;
	protected $newCode;
	protected $Cdp05000RoteiroProducaoFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $Cdp05000RoteiroProducaoFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->Cdp05000RoteiroProducaoFactory = $Cdp05000RoteiroProducaoFactory;
	}
	
	public function roteiroDeleteFilhos($rows){
		switch ($rows['WIDGET_NAME']) {
		    case "processo_de_fabricacao":
		        $this->roteiroDeleteProcessoFabric($rows);
		        break;
		    case "etapa_da_producao":
		        $this->roteiroDeleteEtapaProd($rows);
		        break;
		    case "atividade_etapa":
		        $this->roteiroDeleteAtividadesEtapa($rows);
		        break;
		}
	}
	
	public function roteiroDeleteProcessoFabric($rows){
        try{
        	
            $ProcessoFabric = $this->Cdp05000RoteiroProducaoFactory->selectProcessoFabricacao($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC']);
            if($ProcessoFabric){
                $EtapaProd = $this->Cdp05000RoteiroProducaoFactory->selectEtapaProd($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC']);
            	if($EtapaProd){
            		foreach ($EtapaProd as $EtapaProdValue){
                		$MateriaPrima = $this->Cdp05000RoteiroProducaoFactory->selectMateriaPrima($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue["CDETAPAPROD"], $rows['CDPROCFABRIC']);
                		$AtividadesEtapa = $this->Cdp05000RoteiroProducaoFactory->selectAtividadesEtapa($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            			
            			if($MateriaPrima){
            				$this->Cdp05000RoteiroProducaoFactory->deleteMateriaPrima($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            			}
            			if($AtividadesEtapa){
            				foreach ($AtividadesEtapa as $AtividadesEtapaValue){
                				$RecursoAtividade = $this->Cdp05000RoteiroProducaoFactory->selectRecursoAtividade($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $EtapaProdValue['CDETAPAPROD'], $AtividadesEtapaValue['CDINSPECAO'], $AtividadesEtapaValue['NRINSPETAPA']);
            					if($RecursoAtividade){
                					$this->Cdp05000RoteiroProducaoFactory->deleteRecursoAtividade($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $EtapaProdValue['CDETAPAPROD'], $AtividadesEtapaValue['CDINSPECAO'], $AtividadesEtapaValue['NRINSPETAPA']);
            					}
            				}
            				$this->Cdp05000RoteiroProducaoFactory->deleteAtividadesEtapa($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            			}
            		}
            		$this->Cdp05000RoteiroProducaoFactory->deleteEtapaProd($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC']);
            	}
            	$this->Cdp05000RoteiroProducaoFactory->deleteProcessoFabricacao($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC']);
            }
        	
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    public function roteiroDeleteEtapaProd($rows){
        try{
        	    $EtapaProd = $this->Cdp05000RoteiroProducaoFactory->selectEtapaProd($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC']);
            	if($EtapaProd){
            		foreach ($EtapaProd as $EtapaProdValue){
                		$MateriaPrima = $this->Cdp05000RoteiroProducaoFactory->selectMateriaPrima($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue["CDETAPAPROD"], $rows['CDPROCFABRIC']);
                		$AtividadesEtapa = $this->Cdp05000RoteiroProducaoFactory->selectAtividadesEtapa($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            			
            			if($MateriaPrima){
            				$this->Cdp05000RoteiroProducaoFactory->deleteMateriaPrima($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            			}
            			if($AtividadesEtapa){
            				foreach ($AtividadesEtapa as $AtividadesEtapaValue){
                				$RecursoAtividade = $this->Cdp05000RoteiroProducaoFactory->selectRecursoAtividade($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $EtapaProdValue['CDETAPAPROD'], $AtividadesEtapaValue['CDINSPECAO'], $AtividadesEtapaValue['NRINSPETAPA']);
            					if($RecursoAtividade){
                					$this->Cdp05000RoteiroProducaoFactory->deleteRecursoAtividade($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $EtapaProdValue['CDETAPAPROD'], $AtividadesEtapaValue['CDINSPECAO'], $AtividadesEtapaValue['NRINSPETAPA']);
            					}
            				}
            				$this->Cdp05000RoteiroProducaoFactory->deleteAtividadesEtapa($rows['CDFILIAL'], $rows['CDPRODUTO'], $EtapaProdValue['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            			}
            		}
            		$this->Cdp05000RoteiroProducaoFactory->deleteEtapaProdPai($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $rows['CDETAPAPROD']);
            	}
           
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    public function roteiroDeleteAtividadesEtapa($rows){
        try{
        	$AtividadesEtapa = $this->Cdp05000RoteiroProducaoFactory->selectAtividadesEtapa($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDETAPAPROD'], $rows['CDPROCFABRIC']);
            if($AtividadesEtapa){
				foreach ($AtividadesEtapa as $AtividadesEtapaValue){
    				$RecursoAtividade = $this->Cdp05000RoteiroProducaoFactory->selectRecursoAtividade($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $rows['CDETAPAPROD'], $AtividadesEtapaValue['CDINSPECAO'], $AtividadesEtapaValue['NRINSPETAPA']);
					if($RecursoAtividade){
    					$this->Cdp05000RoteiroProducaoFactory->deleteRecursoAtividade($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDPROCFABRIC'], $rows['CDETAPAPROD'], $AtividadesEtapaValue['CDINSPECAO'], $AtividadesEtapaValue['NRINSPETAPA']);
					}
				}
				$this->Cdp05000RoteiroProducaoFactory->deleteAtividadesEtapaPai($rows['CDFILIAL'], $rows['CDPRODUTO'], $rows['CDETAPAPROD'], $rows['CDPROCFABRIC'],$rows['CDINSPECAO'], $rows['NRINSPETAPA']);
			}
        
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
}
