<?php

namespace Teknisa\CDP\Modules\Qualidade\Controllers;

use Doctrine\ORM\EntityManager;
use Teknisa\GER\Libraries\PHPMailer;
use Teknisa\CDP\Controllers\TeknisaCrud;
use Teknisa\GER\Controllers\CrudController;
use Teknisa\CDP\Modules\Qualidade\Services\QPR01000ParametrosQualidadeProducaoService as QPR01000ParametrosQualidadeProducaoService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class QPR01000ParametrosQualidadeProducaoController extends TeknisaCrud {
        
        protected $parameterBag;
        protected $dataSourceName;
        protected $ParametrosQualidadeProducaoService;
        
        public function __construct($crudService, ParameterBag $parameterBag, QPR01000ParametrosQualidadeProducaoService $ParametrosQualidadeProducaoService){
            $this->parameterBag = $parameterBag;
            $this->ParametrosQualidadeProducaoService = $ParametrosQualidadeProducaoService;
            parent::__construct($crudService, $parameterBag);
        }
        
        public function findProxConsulta(DTO\Request $request, DTO\Response $response) {
            /*$this->dataSourceName = 'parametroqpr_param_qualidade_prox_consulta';
            parent::find($request, $response);*/
            
            try 
            {
                $row = $request->getDataSet()->getRows()[0];
                $dataSourceName = "parametroqpr_param_qualidade_prox_consulta";
                
                $response->addDataSet(new DataSet($dataSourceName, array ($this->ParametrosQualidadeProducaoService->getProxConsulta($row), $this->ParametrosQualidadeProducaoService->getUltConsulta($row))));
            
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
        
        protected function populateParameterBag(FilterCriteria $filterCriteria) 
        {
    
            $conditions = array();
            foreach ($filterCriteria->getConditions() as $condition) {
                $columnName = $condition['columnName'];
                if (in_array($columnName, $this->parameterBagColumns)) {
                    $this->parameterBag->set($columnName, $this->processConditionValue($condition));
                } else {
                    $conditions[] = $condition;
                }
            }
            $newFilterCriteria = new FilterCriteria(
                $filterCriteria->getDataSourceName(),
                $conditions,
                $filterCriteria->getPage(),
                $filterCriteria->getPageSize()
            );
            return $newFilterCriteria;
        }
        
}